// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"


#pragma comment(lib, "SetupApi.lib")


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// MTCY
#define TSDATASIZE			65536UL										// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		4UL											// obt@ = 4b
#define ASYNCBUFFSIZE		( 0x400000 / TSDATASIZE * ASYNCBUFFTIME )	// 32MbpsƂ

// Gh|CgCfbNX
#define EPINDEX_IN			0UL
#define EPINDEX_OUT			1UL

// R}h
#define CMD_EP6IN_START		0x50U	//
#define	CMD_EP6IN_STOP		0x51U	//
#define	CMD_EP2OUT_START	0x52U	//
#define	CMD_EP2OUT_STOP		0x53U	//
#define	CMD_PORT_CFG		0x54U	//addr_mask, out_pins
#define	CMD_REG_READ		0x55U	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56U	//addr, value
#define	CMD_PORT_READ		0x57U	//(return 1byte)
#define	CMD_PORT_WRITE		0x58U	//value
#define	CMD_IFCONFIG		0x59U	//value
#define	CMD_MODE_IDLE		0x5AU
#define CMD_EP4IN_START		0x5BU	//
#define	CMD_EP4IN_STOP		0x5CU	//
#define	CMD_IR_CODE			0x5DU	//val_l, val_h (0x0000:RBUF capture 0xffff:BWUF output)
#define CMD_IR_WBUF			0x5EU	//ofs(0 or 64 or 128 or 192), len(max 64), data, ....
#define	CMD_IR_RBUF			0x5FU	//ofs(0 or 64 or 128 or 192) (return 64byte)

#define	PIO_START			0x20
#define	PIO_IR_OUT			0x10
#define	PIO_IR_IN			0x08
#define PIO_TS_BACK			0x04

// FX2t@[EFA
static const BYTE abyFirmWare[] =
#include "Fw.inc"


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_pUsbFx2Driver(NULL)
	, m_hOnStreamEvent(NULL)
{
	m_pThis = this;
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	// UN[Y
	CloseTuner();

	// JIUSB FX2̃hCoCX^X
	m_pUsbFx2Driver = new CUsbFx2Driver(this);
	if(!m_pUsbFx2Driver)return false;
	
	try{
		// FIFOobt@m
		AllocFifoBuff();

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 0UL;

		// hCoI[v
		if(!m_pUsbFx2Driver->OpenDriver(0x00U, abyFirmWare, "FX2_FIFO"))throw 0UL;

		// Gh|Cgǉ
		if(!m_pUsbFx2Driver->AddEndPoint(0x81U))throw 1UL;	// EPINDEX_IN
		if(!m_pUsbFx2Driver->AddEndPoint(0x01U))throw 2UL;	// EPINDEX_OUT
		
		// FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		BYTE abySetupCmd[] =
		{
			CMD_PORT_CFG,
			0x00U,
			PIO_START | PIO_IR_OUT | PIO_TS_BACK,
			CMD_MODE_IDLE,
			CMD_IFCONFIG,
			0xE3U
		};

		DWORD dwCmdLen = sizeof(abySetupCmd);
		if(!m_pUsbFx2Driver->TransmitData(EPINDEX_OUT, abySetupCmd, dwCmdLen))throw 3UL;

		// XbhN
		if(!m_pUsbFx2Driver->CreateFifoThread(0x86U, NULL, TSDATASIZE))throw 4UL;

		// JnR}hM
		BYTE abyStartCmd[] =
		{
			CMD_EP6IN_START,
			CMD_PORT_WRITE,
			PIO_START | PIO_IR_OUT | PIO_TS_BACK
		};

		dwCmdLen = sizeof(abyStartCmd);
		if(!m_pUsbFx2Driver->TransmitData(EPINDEX_OUT, abyStartCmd, dwCmdLen))throw 5UL;

		// 
		return TRUE;
		}
	catch(DWORD dwErrorStep){
		// G[
		CloseTuner();

		return FALSE;
		}
}

void CBonTuner::CloseTuner()
{
	// hCo
	if(m_pUsbFx2Driver){
		m_pUsbFx2Driver->CloseDriver();
		delete m_pUsbFx2Driver;
		m_pUsbFx2Driver = NULL;		
		}
		
	// nh
	if(m_hOnStreamEvent){
		::CloseHandle(m_hOnStreamEvent);
		m_hOnStreamEvent = NULL;	
		}
		
	// obt@J
	FreeFifoBuff();
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	// Ȃ
	
	// RMĂ悢DDD
	
	return TRUE;
}

const float CBonTuner::GetSignalLevel(void)
{
	// FIFOobt@FullnessԂ
	return ((float)m_FifoBuffer.size() / (float)ASYNCBUFFSIZE * 100.0f);
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	return 0UL;

	// I`FbN
	if(!m_pUsbFx2Driver)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_pUsbFx2Driver)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_FifoBuffer.size();
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock Lock(&m_CriticalLock);

	if(!m_pUsbFx2Driver)return FALSE;

	// TSf[^obt@o
	if(m_FifoBuffer.size()){
		// f[^Rs[
		*pdwSize = TSDATASIZE;
		*ppDst = m_FifoBuffer.front();
		m_FifoBuffer.pop();

		return TRUE;
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W
	CBlockLock Lock(&m_CriticalLock);
	
	// ̃f[^p[W
	while(!m_FifoBuffer.empty()){
		m_FifoBuffer.pop();
		}
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

const bool CBonTuner::OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver)
{
	CBlockLock Lock(&m_CriticalLock);

	// FIFOobt@ɃvbV
	PushFifoBuff(pData);
	
	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return true;
}

void CBonTuner::AllocFifoBuff(void)
{
	// FIFOobt@p[W
	PurgeTsStream();

	// obt@v[mۂ
	m_BufferPool.resize(ASYNCBUFFSIZE);

	for(DWORD dwPos = 0UL ; dwPos < ASYNCBUFFSIZE ; dwPos++){
		m_BufferPool[dwPos].resize(TSDATASIZE);
		}
		
	m_dwEmptyFifoPos = 0UL;
}

void CBonTuner::FreeFifoBuff(void)
{
	// FIFOobt@p[W
	PurgeTsStream();

	// obt@v[J
	m_BufferPool.clear();
}

void CBonTuner::PushFifoBuff(const BYTE *pData)
{
	// obt@v[̍ő吔𒴂ꍇ͍Ō؂̂Ă
	while(m_FifoBuffer.size() >= ASYNCBUFFSIZE){
		m_FifoBuffer.pop();
		}

	// obt@v[Ƀf[^Rs[
	BYTE *pWritePointer = &m_BufferPool[m_dwEmptyFifoPos][0];
	
	::CopyMemory(pWritePointer, pData, TSDATASIZE);

	// FIFOobt@ɃvbV
	m_FifoBuffer.push(pWritePointer);

	// obt@v[ʒuXV
	if(++m_dwEmptyFifoPos >= ASYNCBUFFSIZE)m_dwEmptyFifoPos = 0UL;
}
